#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

struct Node{
    ll n;
    ll order = -1;
    Node* l = nullptr;
    Node* r = nullptr;
};


void rec(Node& a, vector<ll>& b, ll& ord){
    switch(a.order){
        case(-1):{
            ord++;
            b[a.n] = ord;
            if(a.l != nullptr)
                rec(*a.l, b, ord);
            if(a.r != nullptr)
                rec(*a.r, b, ord);
            break;
        }case(1):{
            if(a.l != nullptr)
                rec(*a.l, b, ord);
            if(a.r != nullptr)
                rec(*a.r, b, ord);
            ord++;
            b[a.n] = ord;
            break;
        }case(0):{
            if(a.l != nullptr)
                rec(*a.l, b, ord);
            ord++;
            b[a.n] = ord;
            if(a.r != nullptr)
                rec(*a.r, b, ord);
            break;
        }
    }
    return;
}


int main()
{
    ll n;
    cin >> n;
    ll q;
    cin >> q;
    vector<Node> a(n);
    ll l, r;
    for(int i = 0; i < n; i++){
        cin >> l >> r;
        if(l != 0){
            a[i].l = &a[l-1];
        }
        if(r != 0){
            a[i].r = &a[r-1];
        }
        a[i].n = i;
    }
    vector<ll> b(n);
    ll t;
    while(q--){
        cin >> t;
        switch(t){
            case(1):{
                ll l, r, x;
                cin >> l >> r >> x;
                l--;
                r--;
                for(int i = l; i <= r; i++){
                    a[i].order = x;
                }
                break;
            }
            case(2):{
                ll i, ord = 0;
                cin >> i;
                rec(a[0], b, ord);
                /*for(int i = 0; i < n; i++){
                    cout << b[i] << " ";
                }*/
                cout << b[i-1] << "\n";
                break;
            }
        }
    }
    return 0;
}
