#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

pair<vector<bool>, vector<bool>> rec(vector<vector<ll>>& a, ll cur_s, ll h, ll w, vector<bool> str, vector<bool> stl, vector<vector<bool>> used, ll s){
    if(cur_s == s){
        return {str, stl};
    }
    if(cur_s > s){
        return {vector<bool>(h, false), vector<bool>(w, false)};
    }
    for(int i = 0; i < h; i++){
        for(int j = 0; j < w; j++){
            if(!used[i][j]){
                cur_s += a[i][j];
                str[i] = true;
                stl[j] = true;
                used[i][j] = true;
                for(int k = 0; k < h; k++){
                    if(str[k] && !used[k][j]){
                        used[k][j] = true;
                        cur_s += a[k][j];
                    }
                }
                for(int k = 0; k < w; k++){
                    if(stl[k] && !used[i][k]){
                        used[i][k] = true;
                        cur_s += a[i][k];
                    }
                }
                return rec(a, cur_s, h, w, str, stl, used, s);
            }
        }
    }
    return {vector<bool>(h, false), vector<bool>(w, false)};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll w, h;
    cin >> h >> w;
    vector<vector<ll>> a(h, vector<ll>(w));
    for(auto& hi: a){
        for(auto& i: hi){
            cin >> i;
        }
    }
    ll s;
    cin >> s;
    vector<bool> str(h, false);
    vector<bool> stl(w, false);
    vector<vector<bool>> used(h, vector<bool>(w, false));
    pair<vector<bool>, vector<bool>> ans = rec(a, 0, h, w, str, stl, used, s);
    bool ch = false;
    ll c = h  + w;
    for(int i = 0; i < w; i++){
            if(ans.first[i]){
                c--;
                ch = true;
            }

    }
    for(int i = 0; i < w; i++){
            if(ans.second[i]){
                c--;
                ch = true;
            }
    }
    if(ch){
        cout << "YES\n";
        cout << c;
    }else{
        cout << "NO";
        return 0;
    }
    for(int i = 0; i < h; i++){
        if(!ans.first[i]){
            cout << 1 << i + 1;
        }
    }
    for(int i = 0; i < w; i++){
        if(!ans.second[i]){
            cout << 2 << i + 1;
        }
    }
    return 0;
}
